
package test3;

import org.jvnet.hk2.annotations.Service;
import org.jvnet.hk2.config.ConfigInjector;
import org.jvnet.hk2.config.Dom;
import org.jvnet.hk2.config.InjectionTarget;

@Service(name = "http-listener", metadata = "target=test3.HttpListener,@id=required,@id=datatype:java.lang.String,@id=leaf,key=@id,keyed-as=test3.HttpListener,@acceptor-threads=optional,@acceptor-threads=datatype:java.lang.String,@acceptor-threads=leaf,@port=optional,@port=default:80,@port=datatype:java.lang.String,@port=leaf")
@InjectionTarget(HttpListener.class)
public class HttpListenerInjector
    extends ConfigInjector<HttpListener>
{


    public void inject(Dom dom, HttpListener target) {
        attribute_id(dom, target);
        attribute_acceptorThreads(dom, target);
        attribute_port(dom, target);
    }

    public void injectAttribute(Dom dom, String name, HttpListener target) {
        if ("id".equals(name)) {
            attribute_id(dom, target);
        }
        if ("acceptor-threads".equals(name)) {
            attribute_acceptorThreads(dom, target);
        }
        if ("port".equals(name)) {
            attribute_port(dom, target);
        }
    }

    public void injectElement(Dom dom, String name, HttpListener target) {
    }

    public void attribute_id(Dom dom, HttpListener target) {
        String v1 = dom.attribute("id");
        target.id = v1;
    }

    public void attribute_acceptorThreads(Dom dom, HttpListener target) {
        String v1 = dom.attribute("acceptor-threads");
        if (v1 == null) {
            return ;
        }
        target.acceptorThreads = asInt(v1);
    }

    public void attribute_port(Dom dom, HttpListener target) {
        String v1 = dom.attribute("port");
        if (v1 == null) {
            return ;
        }
        target.port = asInt(v1);
    }

}
