
package test3;

import java.util.ArrayList;
import java.util.List;
import org.jvnet.hk2.annotations.Service;
import org.jvnet.hk2.config.ConfigInjector;
import org.jvnet.hk2.config.Dom;
import org.jvnet.hk2.config.InjectionTarget;

@Service(name = "virtual-server", metadata = "target=test3.VirtualServer,@http-listeners=optional,@http-listeners=datatype:java.lang.String,@http-listeners=collection:leaf,@http-listeners=reference,@state=optional,@state=datatype:java.lang.String,@state=leaf")
@InjectionTarget(VirtualServer.class)
public class VirtualServerInjector
    extends ConfigInjector<VirtualServer>
{


    public void inject(Dom dom, VirtualServer target) {
        attribute_httpListeners(dom, target);
        attribute_state(dom, target);
    }

    public void injectAttribute(Dom dom, String name, VirtualServer target) {
        if ("http-listeners".equals(name)) {
            attribute_httpListeners(dom, target);
        }
        if ("state".equals(name)) {
            attribute_state(dom, target);
        }
    }

    public void injectElement(Dom dom, String name, VirtualServer target) {
    }

    public void attribute_httpListeners(Dom dom, VirtualServer target) {
        List<String> v1 = dom.attributes("http-listeners");
        if (v1 == null) {
            return ;
        }
        List v2 = new ArrayList<test3.HttpListener>(v1 .size());
        for (String v3 : v1) {
            v2 .add(reference(dom, v3, test3.HttpListener.class));
        }
        target.httpListeners = v2;
    }

    public void attribute_state(Dom dom, VirtualServer target) {
        String v1 = dom.attribute("state");
        if (v1 == null) {
            return ;
        }
        target.state = asBoolean(v1);
    }

}
