
package test3.substitution;

import java.util.ArrayList;
import java.util.List;
import org.jvnet.hk2.annotations.Service;
import org.jvnet.hk2.config.ConfigInjector;
import org.jvnet.hk2.config.Dom;
import org.jvnet.hk2.config.InjectionTarget;

@Service(name = "security-map", metadata = "target=test3.substitution.SecurityMap,<backend-principal>=test3.substitution.Principal")
@InjectionTarget(SecurityMap.class)
public class SecurityMapInjector
    extends ConfigInjector<SecurityMap>
{


    public void inject(Dom dom, SecurityMap target) {
        element_subjects(dom, target);
        element_backendPrincipal(dom, target);
    }

    public void injectAttribute(Dom dom, String name, SecurityMap target) {
    }

    public void injectElement(Dom dom, String name, SecurityMap target) {
        if ("*".equals(name)) {
            element_subjects(dom, target);
        }
        if ("backend-principal".equals(name)) {
            element_backendPrincipal(dom, target);
        }
    }

    public void element_subjects(Dom dom, SecurityMap target) {
        List<test3.substitution.Subject> v1 = dom.nodeByTypeElements(test3.substitution.Subject.class);
        if (v1 == null) {
            return ;
        }
        List v2 = new ArrayList<test3.substitution.Subject>(v1 .size());
        for (test3.substitution.Subject v3 : v1) {
            v2 .add(v3);
        }
        target.subjects = v2;
    }

    public void element_backendPrincipal(Dom dom, SecurityMap target) {
        Dom v1 = dom.nodeElement("backend-principal");
        if (v1 == null) {
            return ;
        }
        target.backendPrincipal = ((Principal) v1 .get());
    }

}
